-- CAMERA FUNCTIONS
-- for some reason splitscreen is VERY funky (read: absolutely idiotic) when it comes to cameras
-- so this is a solution I think: make "local" cameras of the displayplayers via LUA that we can control
local camdata = {}

hud.add(function(v, p, cam)
	for i = 0, 3
	do
		if (not displayplayers[i]) then continue; end -- avoid shitty nilchecks
		
		if (p == displayplayers[i]) 
			camdata[i] = {cam.x, cam.y, cam.z, cam.angle}; 
		end
	end
end)

rawset (_G, "P_GetCameraAngle", function(p)
	for i = 0, 3
	do
		if (not displayplayers[i]) then continue; end -- ditto
		
		if (p == displayplayers[i]) then return camdata[i][4]; end
	end
	
	if (not (p.mo and p.mo.valid)) then return 0; end
	
	return R_PointToAngle(p.mo.x, p.mo.y);
end)

rawset (_G, "P_GetCameraDist", function(p)
	local camx, camy;
	
	for i = 0, 3
	do
		if (not displayplayers[i]) then continue; end -- ditto
		
		if (p == displayplayers[i]) 
			camx = camdata[i][1]; 
			camy = camdata[i][2];
		end
	end
	
	if (not (camx and camy)) then return 0; end -- we don't get any positions, return zilch
	
	if (not (p.mo and p.mo.valid)) then return 0; end
	
	return R_PointToDist2(camx, camy, p.mo.x, p.mo.y);
end)

rawset (_G, "P_GetCameraDist3D", function(p)
	local camx, camy, camz;
	
	for i = 0, 3
	do
		if (not displayplayers[i]) then continue; end -- ditto
		
		if (p == displayplayers[i]) 
			camx = camdata[i][1]; 
			camy = camdata[i][2];
            camz = camdata[i][3];
		end
	end
	
	if (not (camx and camy and camz)) then return 0; end -- we don't get any positions, return zilch
	
	if (not (p.mo and p.mo.valid)) then return 0; end
	
    local dist2D = R_PointToDist2(camx, camy, p.mo.x, p.mo.y);
    
	return R_PointToDist2(0, camz, dist2D, p.mo.z);
end)