-- MERGELIB
-- BLUA merge sort
-- don't ask.
-- original code comes from here: https://gist.github.com/biomood/1132659

--[[ Implementation of MergeSort --]]

local huge = 99254740992 -- uhhhhhhh

rawset(_G, "arrayMerging", false)
local runTest = false -- run the basic verification test

local function getFloor(n) -- this was supposed to be in fracs the whole time I fucking HATE BLUA
    local result = FixedFloor(n*FRACUNIT)
    result = $/FRACUNIT
    return result
end

-- merge an array split from p-q, q-r
local function merge(A, p, q, r)
	local n1 = q-p+1
	local n2 = r-q
	local left = {}
	local right = {}
	
	for i=1, n1 do
		left[i] = A[p+i-1]
	end
	for i=1, n2 do
		right[i] = A[q+i]
	end
	
	left[n1+1] = huge
	right[n2+1] = huge
	
	local i=1
	local j=1
	
	for k=p, r do
		if left[i]<=right[j] then
			A[k] = left[i]
			i=i+1
		else
			A[k] = right[j]
			j=j+1
		end
	end
end

-- main mergesort algorithm
rawset(_G, "mergeSort", function(A, p, r)
	if p < r then
		arrayMerging = true
		local q = getFloor((p + r)/2)
		mergeSort(A, p, q)
		mergeSort(A, q+1, r)
		merge(A, p, q, r)
		arrayMerging = false
	end
end)



-- fill A with random numbers between 1 and 100
local function randArray(A)
	for i=1, 100 do
		A[i] = P_RandomKey(100)
	end
end

-- print all the elements in the array A
rawset(_G, "printArray", function(A) -- rawsetting for debug purposes
	for i=1,#A do
		print(A[i] .. ", ")
	end
	print("\n")
end)

if (runTest)
    local A = { 12, 11, 13, 5, 6, 7 };
    local B = {};

    -- create the original array
    randArray(B)
    print("Original Array B\n")
    printArray(B)
    print("\n")

    -- sort the array
    mergeSort(A, 1, #A)
    print("Sorted Array A\n")
    printArray(A)

    mergeSort(B, 1, #B)
    print("Sorted Array B\n")
    printArray(B)
else
    print("Merge-sort for SRB2 is ready.")
end